#include <bits/stdc++.h>
//#include <windows.h>

#define bug cout<<"bug "<<__LINE__<<endl
#define index xedni
//#define int long long

const int inf=1e9+7;
const int MOD=1e9+7;
const int MAXN=550;

using namespace std;

int n, m, a, b;
int dis[MAXN][MAXN];
int kx[4] = {1, -1, 0, 0};
int ky[4] = {0, 0, 1, -1};

signed main() {
//	freopen(".in", "r", stdin);
//	freopen(".out", "w", stdout);
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    cin >> n >> m >> a >> b;

    for(int i = 1; i <= n; i++) {
        for(int j = 1; j <= m; j++) {
            dis[i][j] = inf;
        }
    }

    queue<pair<int, int> > q;

    for(int i = 1; i <= a; i++) {
        int x, y;
        cin >> x >> y;
        dis[x][y] = 0;
        q.push(make_pair(x, y));
    }

    while(!q.empty()) {
        pair<int, int> pos = q.front();
        q.pop();
        int x = pos.first, y = pos.second;

        for(int k = 0; k <= 3; k++) {
            int nx = x + kx[k];
            int ny = y + ky[k];
            if(nx < 1 || ny < 1 || nx > n || ny > m) {
                continue;
            }
            if(dis[nx][ny] != inf) {
                continue;
            }
            dis[nx][ny] = dis[x][y] + 1;
            q.push(make_pair(nx, ny));
        }
    }

    for(int i = 1; i <= b; i++) {
        int x, y;
        cin >> x >> y;
        cout << dis[x][y] << '\n';
    }

    return 0;
}