#include <bits/stdc++.h>
//#include <windows.h>

#define bug cout<<"bug "<<__LINE__<<endl
#define index xedni
//#define int long long

const int inf=1e9+7;
const int MOD=1e9+7;
const int MAXN=450;

using namespace std;

int n, m, initx, inity;
int kx[8] = {2, -2, 2, -2, 1, -1, 1, -1};
int ky[8] = {1, 1, -1, -1, 2, 2, -2, -2};

int dis[MAXN][MAXN];

signed main() {
//	freopen(".in", "r", stdin);
//	freopen(".out", "w", stdout);
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    cin >> n >> m >> initx >> inity;

    for(int i = 1; i <= n; i++) {
        for(int j = 1; j <= m; j++) {
            dis[i][j] = inf;
        }
    }

    queue<pair<int, int> > q;
    q.push(make_pair(initx, inity));
    dis[initx][inity] = 0;

    while(!q.empty()) {
        pair<int, int> cur = q.front();
        q.pop();
        int x = cur.first, y = cur.second;
        for(int k = 0; k <= 7; k++) {
            int nx = x + kx[k];
            int ny = y + ky[k];
            if(nx < 1 || ny < 1 || nx > n || ny > m) {
                continue;
            }
            if(dis[nx][ny] > dis[x][y] + 1) {
                dis[nx][ny] = dis[x][y] + 1;
                q.push(make_pair(nx, ny));
            }
        }
    }

    for(int i = 1; i <= n; i++) {
        for(int j = 1; j <= m; j++) {
            cout << (dis[i][j] == inf ? -1 : dis[i][j]) << " ";
        } cout << endl;
    }

    return 0;
}