#include <bits/stdc++.h>
//#include <windows.h>

#define bug cout<<"bug "<<__LINE__<<endl
#define index xedni
//#define int long long

const int inf=1e9+7;
const int MOD=1e9+7;
const int MAXN=10;

using namespace std;

int n, m, ans;
int a[MAXN][MAXN], used[MAXN][MAXN];
int kx[8] = {1, 1, 1, -1, -1, -1, 0, 0};
int ky[8] = {1, 0, -1, 1, 0, -1, 1, -1};

void Dfs(int x, int y, int score) {
    if(x == n + 1) {
        ans = max(ans, score);
        return ;
    }
    int nx = x, ny = y + 1;
    if(ny == m + 1) {
        nx ++, ny = 1;
    }
    Dfs(nx, ny, score);
    bool flag = 0;
    for(int k = 0; k <= 7; k++) {
        flag |= used[x + kx[k]][y + ky[k]];
    }
    if(!flag) {
        used[x][y] = 1;
        Dfs(nx, ny, score + a[x][y]);
        used[x][y] = 0;
    }
}

signed main() {
//	freopen(".in", "r", stdin);
//	freopen(".out", "w", stdout);
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int T;
    cin >> T;
    while(T--) {
        memset(used, 0, sizeof(used));
        ans = 0;
        cin >> n >> m;
        for(int i = 1; i <= n; i++) {
            for(int j = 1; j <= m; j++) {
                cin >> a[i][j];
            }
        }
        Dfs(1, 1, 0);
        cout << ans << endl;
    }

    return 0;
}